// DialogConfigTab2.cpp : @
//

#include "stdafx.h"
#include "VTC1021_Utility.h"
#include "DialogConfigTab2.h"
#include "VTC1021.h"
#include "VTC1021_UtilityDlg.h"


// CDialogConfigTab2 ܤ

IMPLEMENT_DYNAMIC(CDialogConfigTab2, CDialog)

CDialogConfigTab2::CDialogConfigTab2(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogConfigTab2::IDD, pParent)
{
	m_isDoCommand = FALSE;
}

CDialogConfigTab2::~CDialogConfigTab2()
{
}

void CDialogConfigTab2::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT1, m_CEdit_WakeOnLan);
	DDX_Control(pDX, IDC_COMBO1, m_CComboBox_WakeOnLan);
	DDX_Control(pDX, IDC_EDIT2, m_CEdit_MDI1_Status);
	DDX_Control(pDX, IDC_EDIT3, m_CEdit_MDI2_Status);
	DDX_Control(pDX, IDC_EDIT4, m_CEdit_MDI3_Status);
	DDX_Control(pDX, IDC_EDIT5, m_CEdit_MDO1_Status);
	DDX_Control(pDX, IDC_COMBO2, m_CComboBox_MDO1_Status);
	DDX_Control(pDX, IDC_EDIT6, m_CEdit_MDO2_Status);
	DDX_Control(pDX, IDC_COMBO3, m_CComboBox_MDO2_Status);
	DDX_Control(pDX, IDC_EDIT7, m_CEdit_MDO3_Status);
	DDX_Control(pDX, IDC_COMBO4, m_CComboBox_MDO3_Status);
	DDX_Control(pDX, IDC_EDIT8, m_CEdit_CANIMP);
	DDX_Control(pDX, IDC_COMBO5, m_CComboBox_CANIMP);
}


BEGIN_MESSAGE_MAP(CDialogConfigTab2, CDialog)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON1, &CDialogConfigTab2::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CDialogConfigTab2::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CDialogConfigTab2::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CDialogConfigTab2::OnBnClickedButton4)
END_MESSAGE_MAP()


// CDialogConfigTab2 TBz`

BOOL CDialogConfigTab2::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here

	m_CComboBox_MDO1_Status.ResetContent();
	m_CComboBox_MDO1_Status.InsertString(0, TEXT("Low"));
	m_CComboBox_MDO1_Status.InsertString(1, TEXT("High"));
	m_CComboBox_MDO1_Status.SetCurSel(0);

	m_CComboBox_MDO2_Status.ResetContent();
	m_CComboBox_MDO2_Status.InsertString(0, TEXT("Low"));
	m_CComboBox_MDO2_Status.InsertString(1, TEXT("High"));
	m_CComboBox_MDO2_Status.SetCurSel(0);

	m_CComboBox_MDO3_Status.ResetContent();
	m_CComboBox_MDO3_Status.InsertString(0, TEXT("Low"));
	m_CComboBox_MDO3_Status.InsertString(1, TEXT("High"));
	m_CComboBox_MDO3_Status.SetCurSel(0);

	m_CComboBox_WakeOnLan.ResetContent();
	m_CComboBox_WakeOnLan.InsertString(0, TEXT("Disable"));
	m_CComboBox_WakeOnLan.InsertString(1, TEXT("Enable"));
	m_CComboBox_WakeOnLan.SetCurSel(0);

	m_CComboBox_CANIMP.ResetContent();
	m_CComboBox_CANIMP.InsertString(0, TEXT("Disable"));
	m_CComboBox_CANIMP.InsertString(1, TEXT("Enable"));
	m_CComboBox_CANIMP.SetCurSel(1);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDialogConfigTab2::OnTimer(UINT_PTR nIDEvent)
{
	if( 1 == nIDEvent )
	{
		KillTimer(1);

		switch( m_nStep )
		{
		case 0: fnGetWakeOnLanStatus();		m_nStep++; break;
		case 1: fnGetMDIStatus();			m_nStep++; break;
		case 2: fnGetMDOStatus();			m_nStep++; break;
		case 3: fnGetCANIMPStatus();		m_nStep++; break;
		default: break;
		}

		if( m_nStep < 4 )
			SetTimer(1, 100, NULL);
	}

	CDialog::OnTimer(nIDEvent);
}

void CDialogConfigTab2::OnBnClickedButton1()
{
	unsigned int nEnable  = m_CComboBox_WakeOnLan.GetCurSel();
	int nResult = SetWakeOnLanControl(nEnable);
	if( nResult == 1 )
	{
		CVTC1021_UtilityDlg* p_MainDlg = (CVTC1021_UtilityDlg *)AfxGetMainWnd();
		if( p_MainDlg ) p_MainDlg->m_CEdit_Message.SetWindowText(TEXT("Set Wake On Lan Success."));

		fnGetWakeOnLanStatus();
	}
	else
	{
		CVTC1021_UtilityDlg* p_MainDlg = (CVTC1021_UtilityDlg *)AfxGetMainWnd();
		if( p_MainDlg ) p_MainDlg->m_CEdit_Message.SetWindowText(TEXT("Set Wake On Lan Failed!!!"));
	}
}

void CDialogConfigTab2::OnBnClickedButton2()
{
	fnGetMDIStatus();
}

void CDialogConfigTab2::OnBnClickedButton3()
{
	int nMDO1 = m_CComboBox_MDO1_Status.GetCurSel();
	int nMDO2 = m_CComboBox_MDO2_Status.GetCurSel();
	int nMDO3 = m_CComboBox_MDO3_Status.GetCurSel();
	int nResult = SetMDOControl(nMDO1, nMDO2, nMDO3);
	if( nResult == 1 )
	{
		CVTC1021_UtilityDlg* p_MainDlg = (CVTC1021_UtilityDlg *)AfxGetMainWnd();
		if( p_MainDlg ) p_MainDlg->m_CEdit_Message.SetWindowText(TEXT("Set MDO Control Success."));

		fnGetMDOStatus();
	}
	else
	{
		CVTC1021_UtilityDlg* p_MainDlg = (CVTC1021_UtilityDlg *)AfxGetMainWnd();
		if( p_MainDlg ) p_MainDlg->m_CEdit_Message.SetWindowText(TEXT("Set MDO Control Failed!!!"));
	}
}

void CDialogConfigTab2::OnBnClickedButton4()
{
	unsigned int nEnable  = m_CComboBox_CANIMP.GetCurSel();
	int nResult = SetCANIMPControl(nEnable);
	if( nResult == 1 )
	{
		CVTC1021_UtilityDlg* p_MainDlg = (CVTC1021_UtilityDlg *)AfxGetMainWnd();
		if( p_MainDlg ) p_MainDlg->m_CEdit_Message.SetWindowText(TEXT("Set CAN Impedance Success."));

		fnGetCANIMPStatus();
	}
	else
	{
		CVTC1021_UtilityDlg* p_MainDlg = (CVTC1021_UtilityDlg *)AfxGetMainWnd();
		if( p_MainDlg ) p_MainDlg->m_CEdit_Message.SetWindowText(TEXT("Set CAN Impedance Failed!!!"));
	}
}

void CDialogConfigTab2::fnGetWakeOnLanStatus()
{
	int nWakeOnLanStatus = 0;
	int nResult = GetWakeOnLanStatus(&nWakeOnLanStatus);
	if( nResult == 1 )
	{
		CString strWakeOnLanStatus;
		switch(nWakeOnLanStatus)
		{
		case 0: strWakeOnLanStatus = TEXT("Disable"); break;
		case 1: strWakeOnLanStatus = TEXT("Enable"); break;
		default: strWakeOnLanStatus = TEXT("Undefined"); break;
		}
		m_CEdit_WakeOnLan.SetWindowText(strWakeOnLanStatus);
	}
	else
	{
		m_CEdit_WakeOnLan.SetWindowText(TEXT("?"));
	}
}

void CDialogConfigTab2::fnGetMDIStatus()
{
	int nMDI1;
	int nMDI2;
	int nMDI3;
	int nResult = GetMDIStatus(&nMDI1, &nMDI2, &nMDI3);
	if( nResult == 1 )
	{
		CString strMDI1Status;
		switch(nMDI1)
		{
		case 0: strMDI1Status = TEXT("Low"); break;
		case 1: strMDI1Status = TEXT("High"); break;
		default: strMDI1Status = TEXT("Undefined"); break;
		}
		m_CEdit_MDI1_Status.SetWindowText(strMDI1Status);

		CString strMDI2Status;
		switch(nMDI2)
		{
		case 0: strMDI2Status = TEXT("Low"); break;
		case 1: strMDI2Status = TEXT("High"); break;
		default: strMDI2Status = TEXT("Undefined"); break;
		}
		m_CEdit_MDI2_Status.SetWindowText(strMDI2Status);

		CString strMDI3Status;
		switch(nMDI3)
		{
		case 0: strMDI3Status = TEXT("Low"); break;
		case 1: strMDI3Status = TEXT("High"); break;
		default: strMDI3Status = TEXT("Undefined"); break;
		}
		m_CEdit_MDI3_Status.SetWindowText(strMDI3Status);
	}
	else
	{
		m_CEdit_MDI1_Status.SetWindowText(TEXT("?"));
		m_CEdit_MDI2_Status.SetWindowText(TEXT("?"));
		m_CEdit_MDI3_Status.SetWindowText(TEXT("?"));
	}
}

void CDialogConfigTab2::fnGetMDOStatus()
{
	int nMDO1;
	int nMDO2;
	int nMDO3;
	int nResult = GetMDOStatus(&nMDO1, &nMDO2, &nMDO3);
	if( nResult == 1 )
	{
		CString strMDO1Status;
		switch(nMDO1)
		{
		case 0: strMDO1Status = TEXT("Low"); break;
		case 1: strMDO1Status = TEXT("High"); break;
		default: strMDO1Status = TEXT("Undefined"); break;
		}
		m_CEdit_MDO1_Status.SetWindowText(strMDO1Status);

		CString strMDO2Status;
		switch(nMDO2)
		{
		case 0: strMDO2Status = TEXT("Low"); break;
		case 1: strMDO2Status = TEXT("High"); break;
		default: strMDO2Status = TEXT("Undefined"); break;
		}
		m_CEdit_MDO2_Status.SetWindowText(strMDO2Status);

		CString strMDO3Status;
		switch(nMDO3)
		{
		case 0: strMDO3Status = TEXT("Low"); break;
		case 1: strMDO3Status = TEXT("High"); break;
		default: strMDO3Status = TEXT("Undefined"); break;
		}
		m_CEdit_MDO3_Status.SetWindowText(strMDO3Status);
	}
	else
	{
		m_CEdit_MDO1_Status.SetWindowText(TEXT("?"));
		m_CEdit_MDO2_Status.SetWindowText(TEXT("?"));
		m_CEdit_MDO3_Status.SetWindowText(TEXT("?"));
	}
}

void CDialogConfigTab2::fnGetCANIMPStatus()
{
	int nCANIMPStatus;
	int nResult = GetCANIMPStatus(&nCANIMPStatus);
	if( nResult == 1 )
	{
		CString strCANIMPStatus;
		switch(nCANIMPStatus)
		{
		case 0: strCANIMPStatus = TEXT("Disable"); break;
		case 1: strCANIMPStatus = TEXT("Enable"); break;
		default: strCANIMPStatus = TEXT("Undefined"); break;
		}
		m_CEdit_CANIMP.SetWindowText(strCANIMPStatus);
	}
	else
	{
		m_CEdit_CANIMP.SetWindowText(TEXT("?"));
	}
}

void CDialogConfigTab2::DoCommand()
{
	if( FALSE == m_isDoCommand )
	{
		m_isDoCommand = TRUE;
		m_nStep = 0;
		SetTimer(1, 0, NULL);
	}
}
