// DialogConfigTab7.cpp : @
//

#include "stdafx.h"
#include "VTC1021_Utility.h"
#include "DialogConfigTab7.h"
#include "VTC1021.h"


CDialogConfigTab7 *g_pCDialogConfigTab7 = NULL;

void EventSystemAlarm(unsigned char byAlarm)
{
	if( byAlarm & 0x01 )
		g_pCDialogConfigTab7->AddEventMessage(TEXT("Over voltage"));

	if( byAlarm & 0x02 )
		g_pCDialogConfigTab7->AddEventMessage(TEXT("Lower voltage"));

	if( byAlarm & 0x04 )
		g_pCDialogConfigTab7->AddEventMessage(TEXT("Over temperature"));

	if( byAlarm & 0x08 )
		g_pCDialogConfigTab7->AddEventMessage(TEXT("Lower temperature"));
}


// CDialogConfigTab7 ܤ

IMPLEMENT_DYNAMIC(CDialogConfigTab7, CDialog)

CDialogConfigTab7::CDialogConfigTab7(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogConfigTab7::IDD, pParent)
{

}

CDialogConfigTab7::~CDialogConfigTab7()
{
}

void CDialogConfigTab7::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST1, m_CListBox_Event);
}


BEGIN_MESSAGE_MAP(CDialogConfigTab7, CDialog)
END_MESSAGE_MAP()


// CDialogConfigTab7 TBz`

BOOL CDialogConfigTab7::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here

	g_pCDialogConfigTab7 = this;

	RegisterSystemAlarmCallBackFunction(EventSystemAlarm);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDialogConfigTab7::AddEventMessage(CString strMessage)
{
	SYSTEMTIME systemTime;
	GetLocalTime(&systemTime);

	CString strData;
	strData.Format(TEXT("%d/%d/%d %d:%d:%d %s"), systemTime.wYear, systemTime.wMonth, systemTime.wDay, systemTime.wHour, systemTime.wMinute, systemTime.wSecond, strMessage);

	while ( m_CListBox_Event.GetCount() >= 100 )
	{
		m_CListBox_Event.DeleteString(0);
	}

	int nCount = m_CListBox_Event.GetCount();
	m_CListBox_Event.InsertString(nCount, strData);

	nCount = m_CListBox_Event.GetCount();
	m_CListBox_Event.SetCaretIndex(nCount);
}
